//
//  GameShaders.metal
//  MetalRenderer
//
//  Created by Caroline on 20/2/20.
//  Copyright © 2020 Razeware. All rights reserved.
//

#include <metal_stdlib>
using namespace metal;
#import <simd/simd.h>

typedef struct {
  matrix_float4x4 modelMatrix;
  matrix_float4x4 viewMatrix;
  matrix_float4x4 projectionMatrix;
} Uniforms;


vertex float4 vertex_new(constant float3 *vertices [[buffer(0)]],
                          constant Uniforms &uniforms [[buffer(21)]],
                          uint id [[vertex_id]]) {
  
  matrix_float4x4 mvp = uniforms.projectionMatrix * uniforms.viewMatrix * uniforms.modelMatrix;
  float4 position = mvp * float4(vertices[id], 1);
  return position;
}

fragment float4 fragment_new(constant float3 *color [[buffer(22)]]) {
  return float4(*color, 1);
}
